<?php
/*
  ===============================================================
  $Id$ Liberty Reserve USD v0.0.1 - March 3, 2012
  LibertyReserve Payment Gateway Coded by GroovyScripts.net
  ===============================================================
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

  class libertyreserveusd {
    var $code, $title, $description, $enabled;

// class constructor
    function libertyreserveusd() {
      global $order;

      $this->code = 'libertyreserveusd';
      $this->title = MODULE_PAYMENT_LIBERTYRESERVEUSD_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_LIBERTYRESERVEUSD_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_LIBERTYRESERVEUSD_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_LIBERTYRESERVEUSD_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_LIBERTYRESERVEUSD_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_LIBERTYRESERVEUSD_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      $this->form_action_url = 'https://sci.libertyreserve.com';
    }

// class methods
    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return false;
    }

    function process_button() {
      global $order, $currencies, $customer_id;

      $process_button_string = tep_draw_hidden_field('lr_acc', MODULE_PAYMENT_LIBERTYRESERVEUSD_ID) .
                               tep_draw_hidden_field('lr_amnt', number_format($order->info['total'] * $currencies->currencies['USD']['value'], $currencies->currencies['USD']['decimal_places'])) .
							   tep_draw_hidden_field('lr_currency', 'LRUSD') .
                               tep_draw_hidden_field('lr_comments', $customer_id . '-' . date('Ymdhis')) .
                               tep_draw_hidden_field('lr_success_url', tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL')) .
                               tep_draw_hidden_field('lr_fail_url', tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));

      return $process_button_string;
    }

    function before_process() {
      return false;
    }

    function after_process() {
      return false;
    }

    function output_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_LIBERTYRESERVEUSD_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Liberty Reserve USD Module', 'MODULE_PAYMENT_LIBERTYRESERVEUSD_STATUS', 'True', 'Do you want to accept Liberty Reserve USD payments?', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Account #', 'MODULE_PAYMENT_LIBERTYRESERVEUSD_ID', 'U123456', 'The account # to use for the Liberty Reserve USD service', '6', '4', now())"); 
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_LIBERTYRESERVEUSD_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_LIBERTYRESERVEUSD_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_LIBERTYRESERVEUSD_STATUS', 'MODULE_PAYMENT_LIBERTYRESERVEUSD_ID', 'MODULE_PAYMENT_LIBERTYRESERVEUSD_ORDER_STATUS_ID', 'MODULE_PAYMENT_LIBERTYRESERVEUSD_SORT_ORDER');
    }
  }
?>
